2 # build: Generic definitions
4 # Lots of this code have been borrowed or heavily inspired from parts
5 # of kbuild code, which is not credited, but mostly developed by:
7 # Copyright (C) Sam Ravnborg <sam@mars.ravnborg.org>, 2015
8 # Copyright (C) Linus Torvalds <torvalds@linux-foundation.org>, 2015
12 # Convenient variables
18 # Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
19 dot-target = $(dir $@).$(notdir $@)
22 # filename of target with directory and extension stripped
23 basetarget = $(basename $(notdir $@))
26 # The temporary file to save gcc -MD generated dependencies must not
28 depfile = $(subst $(comma),_,$(dot-target).d)
31 # Check if both arguments has same arguments. Result is empty string if equal.
32 arg-check = $(strip $(filter-out $(cmd_$(1)), $(cmd_$@)) \
33 $(filter-out $(cmd_$@), $(cmd_$(1))) )
36 # Escape single quote for use in echo statements
37 escsq = $(subst $(squote),'\$(squote)',$1)
40 # Short version is used, if $(quiet) equals `quiet_', otherwise full one.
41 echo-cmd = $(if $($(quiet)cmd_$(1)),\
42 echo ' $(call escsq,$($(quiet)cmd_$(1)))';)
45 # Replace >$< with >$$< to preserve $ when reloading the .cmd file
47 # Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
49 # Replace >'< with >'\''< to be able to enclose the whole string in '...'
50 # (needed for the shell)
51 make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
54 # Find any prerequisites that is newer than target or that does not exist.
55 # PHONY targets skipped in both cases.
56 any-prereq = $(filter-out $(PHONY),$?) $(filter-out $(PHONY) $(wildcard $^),$^)
59 # Copy dependency data into .cmd file
60 # - gcc -M dependency info
61 # - command line to create object 'cmd_object :='
62 dep-cmd = $(if $(wildcard $(fixdep)), \
63 $(fixdep) $(depfile) $@ '$(make-cmd)' > $(dot-target).tmp; \
65 mv -f $(dot-target).tmp $(dot-target).cmd, \
66 printf '$(pound) cannot find fixdep (%s)\n' $(fixdep) > $(dot-target).cmd; \
67 printf '$(pound) using basic dep data\n\n' >> $(dot-target).cmd; \
68 cat $(depfile) >> $(dot-target).cmd; \
69 printf '\n%s\n' 'cmd_$@ := $(make-cmd)' >> $(dot-target).cmd)
72 # if_changed_dep - execute command if any prerequisite is newer than
73 # target, or command line has changed and update
74 # dependencies in the cmd file
75 if_changed_dep = $(if $(strip $(any-prereq) $(arg-check)), \
77 $(echo-cmd) $(cmd_$(1)); \
80 # if_changed - execute command if any prerequisite is newer than
81 # target, or command line has changed
82 if_changed = $(if $(strip $(any-prereq) $(arg-check)), \
84 $(echo-cmd) $(cmd_$(1)); \
85 printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd)
88 # C flags to be used in rule definitions, includes:
89 # - depfile generation
91 # - per target C flags
92 # - per object C flags
93 # - BUILD_STR macro to allow '-D"$(variable)"' constructs
94 c_flags_1 = -Wp,-MD,$(depfile) -Wp,-MT,$@ $(CFLAGS) -D"BUILD_STR(s)=\#s" $(CFLAGS_$(basetarget).o) $(CFLAGS_$(obj))
95 c_flags_2 = $(filter-out $(CFLAGS_REMOVE_$(basetarget).o), $(c_flags_1))
96 c_flags = $(filter-out $(CFLAGS_REMOVE_$(obj)), $(c_flags_2))
97 cxx_flags = -Wp,-MD,$(depfile) -Wp,-MT,$@ $(CXXFLAGS) -D"BUILD_STR(s)=\#s" $(CXXFLAGS_$(basetarget).o) $(CXXFLAGS_$(obj))
102 host_c_flags = -Wp,-MD,$(depfile) -Wp,-MT,$@ $(HOSTCFLAGS) -D"BUILD_STR(s)=\#s" $(HOSTCFLAGS_$(basetarget).o) $(HOSTCFLAGS_$(obj))
104 # output directory for tests below
108 # Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
109 # Exit code chooses option. "$$TMP" serves as a temporary file and is
110 # automatically cleaned up.
111 try-run = $(shell set -e; \
113 mkdir -p $(TMPOUT); \
114 trap "rm -rf $(TMPOUT)" EXIT; \
115 if ($(1)) >/dev/null 2>&1; \
121 # Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
122 cc-option = $(call try-run, \
123 $(CC) -Werror $(1) -c -x c /dev/null -o "$$TMP",$(1),$(2))
125 # delete partially updated (i.e. corrupted) files on error